/*
 * tmos - init_calls.c
 * 	version 0.0.0
 * 
 * Copyright (C) 2005..2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <tmos/kernel.h>
#include <asm/system.h>

struct init_section {
	unsigned int base;
	unsigned int len;
};

extern __code struct init_section init_sections[4];

void call_initcalls(enum stage stage) __reentrant
{
	/*
	 * change to unsigned int to support more than 127 initcalls.
	 */
	unsigned char i = 0;
	unsigned int base = 0;

	base = init_sections[stage].base;
	i = init_sections[stage].len;

	for (; i > 0; i -= 2, base += 2) {
		void (*init_call)(void) = (void * __force)(void __code *__force)
			(*((uint16_t __code *)(base)));

		init_call();
	}
}

static void dummy(void) __naked
{
	__asm__(
		.area init_calls(CODE,REL,CON)
_init_sections:
		.db s_arch_initcall_sec
		.db (s_arch_initcall_sec >> 8)
		.db l_arch_initcall_sec
		.db (l_arch_initcall_sec >> 8)
		
		.db s_subsys_initcall_sec
		.db (s_subsys_initcall_sec >> 8)
		.db l_subsys_initcall_sec
		.db (l_subsys_initcall_sec >> 8)
		
		.db s_device_initcall_sec
		.db (s_device_initcall_sec >> 8)
		.db l_device_initcall_sec
		.db (l_device_initcall_sec >> 8)

		.db s_late_initcall_sec
		.db (s_late_initcall_sec >> 8)
		.db l_late_initcall_sec
		.db (l_late_initcall_sec >> 8)
		
		.area arch_initcall_sec(CODE,REL,CON)
		.area subsys_initcall_sec(CODE,REL,CON)
		.area device_initcall_sec(CODE,REL,CON)
		.area late_initcall_sec(CODE,REL,CON)
	);
}
