/*
 * aduc - adc.h
 * 	version 0.0.0
 * 
 * Copyright (C) 2005, 2006, 2007  Krzysztof Mazur <krzysiek@podlesie.net>
 * 			     2009  Marek Piwoski <marek@microster.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef ADC_H_INCLUDED
#define ADC_H_INCLUDED

#include <tmos/config.h>

#ifdef CONFIG_ADC

#include <asm/system.h>


void adc_init(void);
int16_t adc_get(unsigned int id);
void adc_set_freq(unsigned long freq) __reentrant;

#ifdef CONFIG_ADC_SYNC
unsigned char adc_sync(unsigned char seq) __reentrant;
void adc_wait_ch(unsigned char ch) __reentrant;
#endif

#else
#define adc_init() do { } while (0)
#define adc_get(id) (0)
#endif

#endif
